<?php

/*
 * addftpuser.php
 * Last modified: Mon Jan 22 17:00:19 CET 2007
 *
 * This script is for adding ftp users to our database
 * and includes the processing script, too
 *
 */

// For database connect, PEAR::DB
require("connect.php");

// Include login check
include("check.php");

// look at the $logged_in var in check.php
//
//  1 = logged in
//  0 = not logged in
//
if($logged_in == 1) {

// Define the errorcode variable
$errorcode = array();

// If data submitted
if(isset($_POST['submit']) || empty($errorcode)) {
	
	// If no username was submitted
	if(!$_POST['username']) {
		if(!in_array("dir", $errorcode)) {
			$errorcode[] = "username";
			$errormsg["username"] = "Field Username is empty";
		}
	}

	// If no password was submitted
	if(!$_POST['password']) {
		if(!in_array("password", $errorcode)) {
			$errorcode[] = "password";
			$errormsg["password"] = "Field Password is empty";
		}
	}

	if(!$_POST['uid']) {
		if(!in_array("uid", $errorcode)) {
			$errorcode[] = "uid";
			$errormsg["uid"] = "Field UID is empty";
		}
	}

	if(!$_POST['gid']) {
		if(!in_array("gid", $errorcode)) {
			$errorcode[] = "gid";
			$errormsg["gid"] = "Field GID is empty";
		}
	}

	if(!$_POST['dir']) {
		if(!in_array("dir", $errorcode)) {
			$errorcode[] = "dir";
			$errormsg["dir"] = "Field Home Dir is empty";
		}
	}

	// check, if username is already taken or not
	$check = "SELECT user FROM users WHERE user = '".$_POST['username']."'";
	$name_check = $db->query($check);
	if(MDB2::isError($name_check)) {
		die($name_check->getMessage());
	}

	$name_check2 = $name_check->numRows();
	if($name_check2 != 0) {
		if(!in_array("username", $errorcode)) {
			$errorcode[] = "username";
			$errormsg["username"] = "Username already exists, choose another one";
		}
	}

	// username characters liked described in pureftpd readme:
	// 
	// -- snippet from README.MySQL --
	// "Please note that a login can only contains common 
	//  characters: A...Z, a...z, 0...9, -, ., _, space, :, @ and '
	//  For security purposes, other characters are forbidden."
	// -- endof snippet --
	//
	// Further, username must be at least 2 characters long, but
	// can't exceed 200 characters (otherwise look at your sql structure)
	// However, sometimes I like to put email addresses as username
	// and they're a bit longer
	$regexp_user = "/^[a-zA-Z0-9\._\-\ :@']{2,200}+$/i";

	// Password can contain of the following characters:
	// a-z A-Z 0-9 - _ . [ ] { } @ : , % ^ & *
	// The rest isn't allowed, such as HTML tags <> etc...
	//
	// Further, password must be at least 6 characters long,
	// but can't exceed 128 characters (refer to your sql structure)
	$regexp_pass = "/^[a-zA-Z0-9\-_\.\[\]\{\}@:,%\^\&\*]{6,128}+$/i";
	
	// Check username for length and characters
	if(!preg_match($regexp_user, $_POST['username'])) {
		if(!in_array("username", $errorcode)) {
			$errorcode[] = "username";
			$errormsg["username"] = "Username is invalid or doesn't contain enough characters";
		}
	}

	// Check password for length and characters
	if(!preg_match($regexp_pass, $_POST['password'])) {
		if(!in_array("password", $errorcode)) {
			$errorcode[] = "password";
			$errormsg["password"] = "Password is invalid or doesn't contain enough characters";
		}
	}

	// Check wether passwords match
	if($_POST['password'] != $_POST['password_confirm']) {
		if(!in_array("password_confirm", $errorcode)) {
			$errorcode[] = "password_confirm";
			$errormsg["password_confirm"] = "Password's didn't match";
		}
		if(!in_array("password", $errorcode)) {
			$errorcode[] = "password";
			$errormsg["password"] = "Password's didn't match";
		}
	}

	// Check UID and GID, it can contain only numbers, it's length should
	// be at least 1 number, and maximal 5 numbers 
	$regexp_uid_gid = "/^[0-9]{1,5}+$/i";

	// Check UID
	if(!preg_match($regexp_uid_gid, $_POST['uid'])) {
		if(!in_array("uid", $errorcode)) {
			$errorcode[] = "uid";
			$errormsg["uid"] = "UID contains invalid characters (only numbers allowed)";
		}
	}

	// Check GID
	if(!preg_match($regexp_uid_gid, $_POST['gid'])) {
		if(!in_array("gid", $errorcode)) {
			$errorcode[] = "gid";
			$errormsg["gid"] = "GID contains invalid characters (only numbers allowed)";
		}
	}

	// Check user ip, it can contain only numbers or points '.', the
	// minimal length should be 7, the maximal 15
	$regexp_userip = "/^[0-9\.]{7,15}+$/i";

	// Check user ip, it can contain only one *, or points and numbers
	if($_POST['userip'] != "*") {
		if(!preg_match($regexp_userip, $_POST['userip'])) {
			$errorcode[] = "userip";
			$errormsg["userip"] = "User IP can contain only: * . or numbers 0-9";
		}
	}

	// Check all other, quotasize, quotafiles, ulbandwidth, dlbandwidth,
	// ulratio, dlratio, all of these can't contain only numbers, the
	// length isn't checked
	$regexp_all = "/^[0-9]+$/i";

	// Check quota size
	if(!preg_match($regexp_all, $_POST['quotasize'])) {
		$errorcode[] = "quotasize";
		$errormsg["quotasize"] = "Quota can contain only numbers";
	}

	// Check quota files
	if(!preg_match($regexp_all, $_POST['quotafiles'])) {
		$errorcode[] = "quotafiles";
		$errormsg["quotafiles"] = "Quota Files can contain only numbers";
	}

	// Check upload bandwidth
	if(!preg_match($regexp_all, $_POST['ulbandwidth'])) {
		$errorcode[] = "ulbandwidth";
		$errormsg["ulbandwidth"] = "Upload Bandwidth can contain only numbers";
	}

	// Check download bandwidth
	if(!preg_match($regexp_all, $_POST['dlbandwidth'])) {
		$errorcode[] = "dlbandwidth";
		$errormsg["dlbandwidth"] = "Download Bandwidth can contain only numbers";
	}

	// Check upload ratio
	if(!preg_match($regexp_all, $_POST['ulratio'])) {
		$errorcode[] = "ulratio";
		$errormsg["ulratio"] = "Upload Ratio can contain only numbers";
	}

	// Check download ratio
	if(!preg_match($regexp_all, $_POST['dlratio'])) {
		$errorcode[] = "dlratio";
		$errormsg["dlratio"] = "Download Ratio can contain only numbers";
	}

	// Comment cannot contain HTML tags
	$regexp_comment = "/(\<|\>)/";

	// Check comment
	if(preg_match($regexp_comment, $_POST['comment'])) {
		$errorcode[] = "comment";
		$errormsg["comment"] = "Comment can't contain HTML tags: < or >";
	}

	// If no errors were generated
	if(empty($errorcode)) {

	// Look at pureftpd's mysql.conf and define it's encryption
	// Older versions of pureftpd encrypt with crypt()
	// and after importing pureftpd.passwd into MySQL 
	// I updated this to crypt()
	// Beware, don't use plaintext or just for testing!!!
	//
	// If you use md5, uncomment the line above
	// (and don't forget to comment the one with crypt()
	//
	// $_POST['password'] = md5($_POST['password']); // MD5
	//
	// If MySQLCrypt is set to crypt, use this
	$_POST['password'] = crypt($_POST['password']); // crypt()

	// The insert query
	$insert = "INSERT INTO users (user, password, uid, gid, dir, quotasize, quotafiles, ulbandwidth, dlbandwidth, ulratio, dlratio, comment) VALUES ('".$_POST['username']."', '".$_POST['password']."', '".$_POST['uid']."', '".$_POST['gid']."', '".$_POST['dir']."', '".$_POST['quotasize']."', '".$_POST['quotafiles']."', '".$_POST['ulbandwidth']."', '".$_POST['dlbandwidth']."', '".$_POST['ulratio']."', '".$_POST['dlratio']."', '".$_POST['comment']."')";

	$add_ftpuser = $db->query($insert);

	if(MDB2::isError($add_ftpuser)) {
		die($add_ftpuser->getMessage());
	}

	// When no errors occured, redirect
	@header("Location: listftpusers.php");
	exit;

	}

} else {

// If no data was submitted or there were errors


include("header.inc.php");

/*
 * Some notes about the form:
 *
 * => username can contain maximal 200 characters and is restricted
 *    to use only specific characters described above
 *
 * => password can contain up to 128 characters and is restricted
 *    to use only specific characters described above
 *
 * => password_confirm has to be the same as password
 *
 * => uid has a maximal size of 5 numeric characters, with this uid the
 *    added ftp user will take actions after connection (user id)
 *
 * => gid has a maximal size of 5 numeric characters, with this gid the
 *    added ftp user will take actions after he connected (group id)
 *
 * => homedir can be up to 200 characters long (including slashes)
 *    and it has to start with a slash / and has to end with a
 *    slash-point-slash /./ because of chrooting. all users with such
 *    a homedir will be chrooted automatically. Be aware, if you don't
 *    use this, users may be able to read other users stuff and 
 *    change or delete it
 *
 * => userip is the ip address with that the user connects to the ftp
 *    server and contain a '*' what means no restriction, or it can
 *    contain only one ip address (no multiple addresses supported yet)
 *
 * => quota can be set in Megabyte [MB]
 *
 * => quota files is the number of files which the user can store in his
 *    ftp homedir
 *
 * => ulbandwidth if you want to set a users upload bandwidth in kbyte/s
 *
 * => dlbandwidth if you want to set a users download bandwidth in kbyte/s
 *
 * => ulratio is the upload ratio
 *
 * => dlratio is the download ratio, so if someone has an ulratio of 1
 *    and a dlratio of 2, his ratio is 1:2, so he has to upload for
 *    example 100 Mb in order to download 200 Mb
 *
 */

?>

<form method="post" action="<?=$PHP_SELF;?>">
<table width="600" class="base" bgcolor="#ffffff" cellpadding="2" cellspacing="1">
 <tr>
  <th colspan="2" align="left">&nbsp;Add FTP User</th>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Username:</b></td>
  <td align="left" width="70%" <? if(in_array("username", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="username" maxlength="200" size="25" <? if(isset($_POST['username'])) { echo "value=\"".$_POST['username']."\""; } ?>>&nbsp;Min 2, max 200 characters<? if(in_array("username", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["username"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Password:</b></td>
  <td align="left" width="70%" <? if(in_array("password", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="password" name="password" maxlength="128" size="25">&nbsp;Min 6, max 128 characters<? if(in_array("password", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["password"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Password confirm:</b></td>
  <td align="left" width="70%" <? if(in_array("password_confirm", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="password" name="password_confirm" maxlength="128" size="25">&nbsp;Repeat password<? if(in_array("password_confirm", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["password_confirm"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>UID:</b></td>
  <td align="left" width="70%" <? if(in_array("uid", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="uid" maxlength="5" size="3" <? if(isset($_POST['uid'])) { echo "value=\"".$_POST['uid']."\""; } ?>>&nbsp;Default UID to connect with<? if(in_array("uid", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["uid"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>GID:</b></td>
  <td align="left" width="70%" <? if(in_array("gid", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="gid" maxlength="5" size="3" <? if(isset($_POST['gid'])) { echo "value=\"".$_POST['gid']."\""; } ?>>&nbsp;Default UID to connect with<? if(in_array("gid", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["gid"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Home Dir:</b></td>
  <td align="left" width="70%" <? if(in_array("dir", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="dir" maxlength="200" size="25" <? if(isset($_POST['dir'])) { echo "value=\"".$_POST['dir']."\""; } ?>>&nbsp; like <b>/home/dir/./</b> (with /./ at the end)<? if(in_array("dir", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["dir"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>User IP:</b></td>
  <td align="left" width="70%" <? if(in_array("userip", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="userip" maxlength="15" size="10" <? if(isset($_POST['userip'])) { echo "value=\"".$_POST['userip']."\""; } else { echo "value=\"*\""; } ?>>&nbsp; like <b>123.1.2.3</b> (<b>*</b> for no restriction)<? if(in_array("userip", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["userip"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Quota:</b></td>
  <td align="left" width="70%" <? if(in_array("quotasize", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="quotasize" maxlength="11" size="2" <? if(isset($_POST['quotasize'])) { echo "value=\"".$_POST['quotasize']."\""; } else { echo "value=\"0\""; } ?>>&nbsp; in Mb (0 for no quota)<? if(in_array("quotasize", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["quotasize"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Quota Files:</b></td>
  <td align="left" width="70%" <? if(in_array("quotafiles", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="quotafiles" maxlength="10" size="2" <? if(isset($_POST['quotafiles'])) { echo "value=\"".$_POST['quotafiles']."\""; } else { echo "value=\"0\""; } ?>>&nbsp; how many files are allowed to store (0 for no limit)<? if(in_array("quotafiles", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["quotafiles"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Upload Bandwidth:</b></td>
  <td align="left" width="70%" <? if(in_array("ulbandwidth", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="ulbandwidth" maxlength="11" size="2" <? if(isset($_POST['ulbandwidth'])) { echo "value=\"".$_POST['ulbandwidth']."\""; } else { echo "value=\"0\""; } ?>>&nbsp; in kbyte/s (0 for no limit)<? if(in_array("ulbandwidth", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["ulbandwidth"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Download Bandwidth:</b></td>
  <td align="left" width="70%" <? if(in_array("dlbandwidth", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="dlbandwidth" maxlength="11" size="2" <? if(isset($_POST['dlbandwidth'])) { echo "value=\"".$_POST['dlbandwidth']."\""; } else { echo "value=\"0\""; } ?>>&nbsp; in kbyte/s (0 for no limit)<? if(in_array("dlbandwidth", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["dlbandwidth"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Upload Ratio:</b></td>
  <td align="left" width="70%" <? if(in_array("ulratio", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="ulratio" maxlength="10" size="2" <? if(isset($_POST['ulratio'])) { echo "value=\"".$_POST['ulratio']."\""; } else { echo "value=\"0\""; } ?>>&nbsp; in numbers (0 for no ratio)<? if(in_array("ulratio", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["ulratio"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%"><b>Download Ratio:</b></td>
  <td align="left" width="70%" <? if(in_array("dlratio", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><input type="text" name="dlratio" maxlength="10" size="2" <? if(isset($_POST['dlratio'])) { echo "value=\"".$_POST['dlratio']."\""; } else { echo "value=\"0\""; } ?>>&nbsp; in numbers (0 for no ratio)<? if(in_array("dlratio", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["dlratio"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="right" width="30%" valign="top"><b>Comment:</b></td>
  <td align="left" width="70%" <? if(in_array("comment", $errorcode)) { echo "style=\"background-color: #ffcccc;\""; } ?>><textarea name="comment" cols="40" rows="3"><? if(isset($_POST['comment'])) { echo $_POST['comment']; } ?></textarea><? if(in_array("comment", $errorcode)) { echo "<br><span class=\"error\">&bull; ".$errormsg["comment"]."</span>"; } ?></td>
 </tr>
 <tr>
  <td align="center" colspan="2"><input type="submit" name="submit" value="Submit">&nbsp;<input type="reset" name="reset" value="Reset"></td>
 </tr>
</table>
</form>

<?

}

include("footer.inc.php");

} else {

	// Redirect if not logged in
	@header("Location: index.php");
	exit;

}

?>
