<?php

/*
 * connect.php
 * Last modified: Mon Jan 22 17:04:30 CET 2007
 *
 * This is the database connection script, included everywhere, where
 * we have to connect or query the database
 *
 */

// Required PEAR::MDB2 file
require_once("MDB2.php");

// Include config file, you can specify in the config.php file
// The datasource, username, password for sql
require("config.php");

// Specify datasource, please do not change this
$dsn = array(
	'phptype'		=>		$conf['sqltype'],	// db layer, mysql or pgsql
	'username'		=>		$conf['sqluser'],	// username for sql server
	'password'		=>		$conf['sqlpass'],	// password
	'hostspec'		=>		$conf['sqlhost'],	// hostname
	'database'		=>		$conf['sqldb'],		// database name
);

$options = array(
	'debug'			=>		8,
	'portability'	=>		MDB2_PORTABILITY_ALL,
);

$db =& MDB2::connect($dsn, $options);
if(PEAR::isError($db)) {
	die($db->getMessage());
}

$db->setFetchMode(MDB2_FETCHMODE_ASSOC);

?>
