<?php

/*
 * listftpusers.php
 * Last modified: Mon Jan 22 17:15:11 CET 2007
 *
 * This script lists our ftpusers from the db
 * It handles some basic actions like:
 * view user, edit user, change password, disable user and delete user
 * These actions will be processed by the getuser.php script
 *
 * Because there's not to much place, only following informations are
 * displayed:  username, homedir, quota, uploadbandwidth, downloadbandwidth
 * and the commands (actions) for every user
 *
 */

// Required db config PEAR::DB
require("connect.php");

// Required to check login
include("check.php");

// Show only, if logged in
if($logged_in == 1) {

// Include Header 
include("header.inc.php");
	
?>

  <table width="760" align="center" class="list" align="left" cellpadding="1" cellspacing="1">
   <tr>
    <th align="left" width="25%">Username</th>
    <th align="left" width="25%">Dir</th>
    <th align="left" width="10%">Quota</th>
    <th align="left" width="10%">Upload</th>
    <th align="left" width="10%">Download</th>
    <th align="center" width="15%">Command</th>
  </tr>

<?php

// MySQL query
$query = "SELECT * FROM users";
$query_user = $db->query($query);

// Fetch into array and loop for each user
while($row = $query_user->fetchRow()) {

$cl = $cl=="hb" ? "hg" : "hb";

// Status
if($row['status'] == "1") {
	$img = "disable.png";
	$alt = "Disable";
	$status = "0";
	$style = "color: #008800;";
} else {
	$img = "enable.png";
	$alt = "Enable";
	$status = "1";
	$style = "color: #ff0000;";
}

// Show Upload/Download bandwidth
if($row['ulbandwidth'] == "0") {
	$ulbw = "unlimited";
} else {
	$ulbw = $row['ulbandwidth']." kb/s";
}

if($row['dlbandwidth'] == "0") {
	$dlbw = "unlimited";
} else {
	$dlbw = $row['dlbandwidth']." kb/s";
}

// Show Quota's
if($row['quotasize'] == "0") {
	$qs = "no quota";
} else {
	$qs = $row['quotasize']." MB";
}

?>

  <tr class="<?=$cl;?>" style="<?=$style;?>">
   <td align="left" width="25%"><?=$row['user'];?></td>
   <td align="left" width="25%"><?=$row['dir'];?></td>
   <td align="left" width="10%"><?=$qs;?></td>
   <td align="left" width="10%"><?=$ulbw;?></td>
   <td align="left" width="10%"><?=$dlbw;?></td>
   <td align="center" width="15%">
    <a title="View user <?=$row['user'];?>" href="getuser.php?a=view&user=<?=$row['user'];?>"><img src="images/view.png" border="0" alt="View"></a>&nbsp;
	<a title="Edit user <?=$row['user'];?>" href="getuser.php?a=edit&user=<?=$row['user'];?>"><img src="images/edit.png" border="0" alt="Edit"></a>&nbsp;
	<a title="Change password of <?=$row['user'];?>" href="getuser.php?a=pwd&user=<?=$row['user'];?>"><img src="images/locked.png" border="0" alt="Change Password"></a>&nbsp;
	<a title="<?=$alt;?> user <?=$row['user'];?>" href="getuser.php?a=chgst&status=<?=$status;?>&user=<? echo $row['user'];?>"><img src="images/<?=$img;?>" alt="<?=$alt;?>" border="0"></a>&nbsp;
	<a title="Delete user <?=$row['user'];?>" href="getuser.php?a=delete&user=<?=$row['user'];?>" OnClick="return confirm('Really delete user \'<?=$row['user'];?>\' ?')"><img src="images/delete.png" border="0" alt="Delete"></a>
   </td>
  </tr>

<?

}

?>

  </table>

  <table width="760" align="center" class="list" align="left" cellpadding="1" cellspacing="0">
   <tr class="hg">
    <td align="center" style="border: 1px solid #cccccc; height: 40px; border-top: 0px;">
	 <img src="/images/view.png" alt="View" border="0">&nbsp;View&nbsp;&nbsp;
	 <img src="/images/edit.png" alt="Edit" border="0">&nbsp;Edit&nbsp;&nbsp;
	 <img src="/images/locked.png" alt="Change Password" border="0">&nbsp;Change Password&nbsp;&nbsp;
	 <img src="/images/disable.png" alt="Disable" border="0">&nbsp;Disable&nbsp;&nbsp;
	 <img src="/images/enable.png" alt="Enable" border="0">&nbsp;Enable&nbsp;&nbsp;
	 <img src="/images/delete.png" alt="Delete" border="0">&nbsp;Delete&nbsp;&nbsp;
	</td>
  </tr>
 </table>

 <table width="1" border="0" align="left" cellpadding="0" cellspacing="0">
  <tr>
   <td width="1" height="10" background="images/blank.gif"></td>
  </tr>
 </table>

<?

// Include Footer
include('footer.inc.php');

} else {

	// Redirect if not logged in
	@header("Location: index.php");
	exit;

}

?>
